#ifndef _SWCD_CPLD_H
#define _SWCD_CPLD_H
#include "swcd_i2c.h"

#define CPLD_SLAVE_ADDR    0x64
#define REBOOT_POWEROFF_REG   0x00
#define WDT_REG     0x18
#define POWEROFF 0xf0
#define REBOOT	 0xc3
#define  DISABLE_WDT          0x40

const static unsigned char poweroff_msg[2]  = {REBOOT_POWEROFF_REG, POWEROFF};
const static unsigned char reboot_msg[2]	= {REBOOT_POWEROFF_REG, REBOOT};

static struct i2c_msg cpld_msgs = {
	.addr   = CPLD_SLAVE_ADDR,
	.flags  = 0,
	.len    = 2,
};

static inline int swcd_reboot(void) {
	struct i2c_adapter *adapter = NULL;
	const static unsigned char reboot_msg[2] = {REBOOT_POWEROFF_REG, REBOOT};
	int ret;
	adapter = i2c_get_adapter(SWCD_I2C_REBOOT_POWEROFF_NR);
	if(adapter == NULL){
		printk("%s() get adapter error !\n", __func__);
		return 1;
	}
	cpld_msgs.buf= reboot_msg;
	ret = i2c_transfer(adapter, &cpld_msgs, 1);
	if(ret != 1) {
		ret = -EIO;
		printk("%s() i2c transferring data is fail\n", __func__);
	} else
		ret = 0;
}
static inline int swcd_poweroff(void) {
	struct i2c_adapter *adapter = NULL;
	int ret, retries;
        const static unsigned char poweroff_msg[2] = {REBOOT_POWEROFF_REG, POWEROFF};
        adapter = i2c_get_adapter(SWCD_I2C_REBOOT_POWEROFF_NR);
        if(adapter == NULL){
                printk("%s() get adapter error !\n", __func__);
                return 1;
        }
        cpld_msgs.buf= poweroff_msg;
        ret = i2c_transfer(adapter, &cpld_msgs, 1);
        if(ret != 1) {
                ret = -EIO;
                printk("%s() i2c transferring data is fail\n", __func__);
        } else
                ret = 0;
}
#endif

